hdu 1242 用bfs求最短路

Rescue

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 21907 Accepted Submission(s): 7801

Problem Description
Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison.

Angel’s friends want to save Angel. Their task is: approach Angel. We assume that “approach Angel” is to get to the position where Angel stays. When there’s a guard in the grid, we must kill him (or her?) to move into the grid. We assume that we moving up, down, right, left takes us 1 unit time, and killing a guard takes 1 unit time, too. And we are strong enough to kill all the guards.

You have to calculate the minimal time to approach Angel. (We can move only UP, DOWN, LEFT and RIGHT, to the neighbor grid within bound, of course.)

Input
First line contains two integers stand for N and M.

Then N lines follows, every line has M characters. “.” stands for road, “a” stands for Angel, and “r” stands for each of Angel’s friend.

Process to the end of the file.

Output
For each test case, your program should output a single integer, standing for the minimal time needed. If such a number does no exist, you should output a line containing “Poor ANGEL has to stay in the prison all his life.”

思路:这是最短路问题,当然要用bfs来做,可是如果用最基础的bfs肯定是会出问题的,因为有‘x’的存在你需要多花1个单位的时间,所以你需要把有’x’的位置放在下一级花费同样时间的队列当中。

#include <algorithm>
#include <cstring>
#include <iostream>
#include <queue>
using namespace std;
typedef pair<int, int> P;
char a[210][210];
int b[210][210];
int vis[210][210];
int n,m;
int sx,sy;
int prove;
int dx[4] = {-1,1,0,0};
int dy[4] = {0,0,1,-1};
//这个顺序很重要,如果换一种方式很可能就会出错。
queue<pair<int, int>>que;
void bfs(int x,int y)
{
//常规的bfs再加一个if判断即可。
    memset(vis, 0, sizeof(vis));
    vis[x][y] = 1;
    b[x][y] = 0;
    que.push(P(x,y));
    while (que.size()) {
        P p = que.front();
        que.pop();
        int x = p.first;
        int y = p.second;
        if (a[x][y] == 'a') {
            break;
        }
        if (a[x][y] == 'x') {
            b[x][y] += 1;
            a[x][y] = '.';
            que.push(P(x,y));
            continue;
            //continue的存在确保了‘x’这个点放到了下一级队列中。
        }
        for (int i = 0; i<4; i++) {
            int x1 = x + dx[i];
            int y1 = y + dy[i];
            if (0<=x1&&x1<n&&0<=y1&&y1<m&&a[x1][y1]!='#'&&vis[x1][y1]==0) {
                b[x1][y1] = b[x][y]+1;
                vis[x1][y1] = 1;
                que.push(P(x1,y1));
            }
        }
    }
}
int main()
{
    while (cin>>n>>m) {
        int x,y,x1,y1;
        for (int i = 0; i<n; i++) {
            for (int j = 0; j<m; j++) {
                cin>>a[i][j];
                if (a[i][j] == 'r') {
                    x = i;y = j;
                }
                if (a[i][j] == 'a') {
                    x1 = i;y1 = j;
                }
            }
        }
        bfs(x,y);
        if (vis[x1][y1]) {
            cout<<b[x1][y1]<<endl;
        }
        else
            cout << "Poor ANGEL has to stay in the prison all his life." << endl;
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
好的,关于 HDU4992 所有原根的问题,我可以给出以下解答: 1. 首先,我们需要知道什么是原根。原根是指模 n 意义下,所有与 n 互质的数 a 的最小正整数 k 次幂对 n 取模的值覆盖了所有与 n 互质的数。简单来说,就是如果一个数 a 是模 n 意义下的原根,那么 a 的任何正整数次幂对 n 取模的值都不相同,且能覆盖所有与 n 互质的数。 2. 为了模 n 意义下的所有原根,我们需要先出与 n 互质的数的个数 phi(n)。phi(n) 可以使用欧拉函数出。 3. 然后,我们需要枚举模 n 意义下的所有数,判断它是否是原根。具体来说,对于每个 a,我们需要判断 a 的每个小于 phi(n) 的正整数次幂对 n 取模的值是否都不相同,且能覆盖所有与 n 互质的数。如果是,那么 a 就是模 n 意义下的原根。 4. 代码实现可以参考以下 Java 代码: ``` import java.util.*; public class Main { static int gcd(int a, int b) { return b == 0 ? a : gcd(b, a % b); } static int phi(int n) { int res = n; for (int i = 2; i * i <= n; i++) { if (n % i == 0) { res = res / i * (i - 1); while (n % i == 0) { n /= i; } } } if (n > 1) { res = res / n * (n - 1); } return res; } static int pow(int a, int b, int mod) { int res = 1; while (b > 0) { if ((b & 1) != 0) { res = res * a % mod; } a = a * a % mod; b >>= 1; } return res; } static boolean check(int a, int n, int phi) { for (int i = 1, j = pow(a, i, n); i <= phi; i++, j = j * a % n) { if (j == 1) { return false; } } return true; } public static void main(String[] args) { Scanner scanner = new Scanner(System.in); while (scanner.hasNext()) { int n = scanner.nextInt(); int phi = phi(n); List<Integer> ans = new ArrayList<>(); for (int i = 1; i < n; i++) { if (gcd(i, n) == 1 && check(i, n, phi)) { ans.add(i); } } Collections.sort(ans); for (int x : ans) { System.out.print(x + " "); } System.out.println(); } } } ``` 其中,gcd 函数用于最大公约数,phi 函数用于欧拉函数,pow 函数用于快速幂模,check 函数用于判断一个数是否是原根。在主函数中,我们依次读入每个 n,出 phi(n),然后枚举模 n 意义下的所有数,判断它是否是原根,将所有原根存入一个 List 中,最后排序输出即可。 希望我的回答能够帮到你,如果你有任何问题,欢迎随时提出。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值